!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      PROGRAM CONVERTLAMP
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      
      REAl*4     CONC [allocatable](:,:,:)
     $          ,ULAMP[allocatable](:,:,:)
     $          ,VLAMP[allocatable](:,:,:)
     $          ,WLAMP[allocatable](:,:,:)
!     $          ,CONCB[allocatable](:,:)

      character*8 label
      character*12 datadirIN
      character*13 datadirOUT

      real undef
      character*8 fileIN
      character*8 fileOUT
      character*3 recNUMsim,cIOLAMP,cJOLAMP
      integer ierror
!------------------------------------------------------------------------!

      datadirIN='../POM_DATA/'
      datadirOUT='../POM_GRADS/'
!FA&PO
      write(*,*) '************************************************'
      write(*,*) '******     CONVERTLAMP       (FA & PO)   *******'
      write(*,*) '************************************************'

      write(*,*) 'numero simulazione?'
      read(*,*) recNUMsim

      write(*,*) 'IOLAMP?'
      read(*,*) cIOLAMP
      write(*,*) 'JOLAMP?'
      read(*,*) cJOLAMP
      

      fileIN='repor'//recNUMsim             
      open(1,file=datadirIN//fileIN//'.txt',status='old') 
       read(1,*)
       read(1,*)
       read(1,'(9X,I10)')MODE
       read(1,*)
       read(1,*)
       read(1,'(9X,I10,11X,I10,11X,I10)))') IM,JM,IO
      read(1,*)
       read(1,'(9X,F10.5,11X,I10)') DAYS,iEND
       read(1,'(9X,F10.5,11X,I10)') PRTD1,iPRINT
      close(1)

      undef=-9999.9

      ALLOCATE(CONC   (1:IM,1:JM,IO:0))
      ALLOCATE(ULAMP  (1:IM,1:JM,IO:0))
      ALLOCATE(VLAMP  (1:IM,1:JM,IO:0))
      ALLOCATE(WLAMP  (1:IM,1:JM,IO:0))
!      ALLOCATE(CONCB  (1:IM,1:JM))
 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      fileIN='CONC_'//recNUMsim        
      open(199,file=datadirIN//fileIN//'.pom',status='old')
      read(199,*)!!! salta dati 
      read(199,*)!!! iniziali

      fileIN='ULAMP'//recNUMsim        
      open(198,file=datadirIN//fileIN//'.pom',status='old')
      read(198,*)!!! salta dati 
      read(198,*)!!! iniziali

      fileIN='VLAMP'//recNUMsim        
      open(197,file=datadirIN//fileIN//'.pom',status='old')
      read(197,*)!!! salta dati 
      read(197,*)!!! iniziali

      fileIN='WLAMP'//recNUMsim        
      open(196,file=datadirIN//fileIN//'.pom',status='old')
      read(196,*)!!! salta dati 
      read(196,*)!!! iniziali

!      fileIN='CONCB'//recNUMsim        
!      open(195,file=datadirIN//fileIN//'.pom',status='old')
!      read(195,*)!!! salta dati 
!      read(195,*)!!! iniziali

      fileOUT='lamp_'//recNUMsim  
      open(99,file=datadirOUT//fileOUT//'.bin',form='unformatted',
     &        recordType='stream',status='new')

!---------------------------------
210   FORMAT(5X,6(2X,E12.5)) 

      iTMAX=INT(iEND/iPRINT)+1
      WRITE(*,*)'ITMAX=',ITMAX
      do it=1,ITMAX
       write(*,*)'it=',it
               
         read(199,*)            !!! label
         read(199,*)            !!! time,scale

         read(198,*)            !!! label
         read(198,*)            !!! time,scale

         read(197,*)            !!! label
         read(197,*)            !!! time,scale

         read(196,*)            !!! label
         read(196,*)            !!! time,scale

!         read(195,*)            !!! label
!         read(195,*)            !!! time,scale

!matrici 2D+t
!         iNUMcol2D=0 
!1012     continue
!         read(195,*)         !!! indici
!         iNUMcolNEW2D=iNUMcol2D+6 
!         do J=JM,1,-1
!          read(195,210) (CONCB(i,j), I=iNUMcol2D+1,iNUMcolNEW2D)
!         enddo
!         iresto2D=IM-iNUMcolNEW2D
!         iNUMcol2D=iNUMcolNEW2D
!         if(iresto2D.eq.0) goto 1022
!         IF(iresto2D.gt.6)THEN   
!          goto  1012
!         ELSE 
!          read(195,*)
!          do J=JM,1,-1
!           read(195,210) (CONCB(i,j), I=iNUmcol2D+1,IM)
!          enddo
!          goto 1022                             
!         ENDIF    
!1022     continue 

!matrici 3D+t
         do k=0,IO,-1           !FA&PO Inizio ciclo su k
            read(199,*)         !!! layer

            read(198,*)         !!! layer

            read(197,*)         !!! layer

            read(196,*)         !!! layer

            iNUMcol=0 
 101        continue
            read(199,*)         !!! indici
            read(198,*)         !!! indici
            read(197,*)         !!! indici
            read(196,*)         !!! indici
            iNUMcolNEW=iNUMcol+6 
            do J=JM,1,-1
               read(199,210) (CONC(i,j,k), I=iNUMcol+1,iNUMcolNEW)

               read(198,210) (ULAMP(i,j,k), I=iNUMcol+1,iNUMcolNEW)

               read(197,210) (VLAMP(i,j,k), I=iNUMcol+1,iNUMcolNEW)

               read(196,210) (WLAMP(i,j,k), I=iNUMcol+1,iNUMcolNEW)
            enddo              !FA&PO finisce il ciclo J=JM,1,-1

            iresto=IM-iNUMcolNEW
            iNUMcol=iNUMcolNEW

            if(iresto.eq.0) goto 102      


            IF(iresto.gt.6)THEN   
               goto  101
            ELSE 

               read(199,*)      !!! indici

               read(198,*)      !!! indici

               read(197,*)      !!! indici

               read(196,*)      !!! indici

               do J=JM,1,-1
                  read(199,210) (CONC(i,j,k), I=iNUmcol+1,IM)

                  read(198,210) (ULAMP(i,j,k), I=iNUmcol+1,IM)

                  read(197,210) (VLAMP(i,j,k), I=iNUmcol+1,IM)

                  read(196,210) (WLAMP(i,j,k), I=iNUmcol+1,IM)
               enddo              !FA&PO finisce il ciclo J=JM,1,-1 

               goto 102                             
            ENDIF    
 102        continue 
         Enddo                  !FA&PO finisce il ciclo su k


!******************   scrittura nel file BIN per GrADS   **********************

!	write(*,*) 'scrittura file '//fileOUT//'.bin'
!	write(10,*) 'scrittura file '//fileOUT//'.bin'

!	do j=JM,1,-1          
!         do i=1,IM            
!           write(99) CONCB(i,j)
!         enddo
!        enddo

         do k=0,IO,-1
            do j=JM,1,-1          
               do i=1,IM            
                  write(99) CONC(i,j,k)
               enddo
            enddo
         enddo

         do k=0,IO,-1
            do j=JM,1,-1          
               do i=1,IM            
                  write(99) ULAMP(i,j,k)
               enddo
            enddo
         enddo

        do k=0,IO,-1
	 do j=JM,1,-1          
          do i=1,IM            
            write(99) VLAMP(i,j,k)
         enddo
        enddo
       enddo

       do k=0,IO,-1
	do j=JM,1,-1          
         do i=1,IM            
           write(99) WLAMP(i,j,k)
         enddo
        enddo
       enddo

      ENDDO                  !FA&PO finisce il ciclo su it
      close(199)                   
      close(198)                   
      close(197)   
      close(196)      
!      close(195)      
      close(99)                   
                                !chiudi tutto

!******************   scrittura del file CTL per GrADS   **********************

!Andre
!      fileOUT='runlamp'//recNUMSIM
!Andre

!      write(*,*) 'scrittura file '//fileOUT//'.ctl'      
!     write(10,*) 'scrittura file '//fileOUT//'.ctl'      
      
      open(98,file=datadirOUT//fileOUT//'.ctl',status='new')


      write(98,11110)'DSET ./'//fileOUT//'.bin   '
!     write(98,11110)'DSET D:\pomGRADS\'//fileOUT//'.bin'
!     write(98,11110)'DSET \\SuperLuasso\pomGRADS\'//fileOUT//'.bin'

      write(98,11110)'TITLE ------- SIMULAZIONE '//recNUMsim//' -------'
      write(98,11109)'UNDEF ',undef
      write(98,11110)'OPTIONS yrev'
 
      mnPRTD1=NINT(PRTD1*24*60)   

      write(98,11113) 'X',IM,' '//cIOLAMP//' 1'
      write(98,11113) 'Y',JM,' '//cJOLAMP//' 1'
      write(98,11113) 'Z',-IO+1,' 0 -1' 
      write(98,11112) 'T',iTMAX,' 00:00Z01JAN2004 ',mnPRTD1
      write(98,11110) 'VARS 4'
!      write(98,11110) 'CONCB  0  99 concentrazione fondo (mmol/m2)'     
      write(98,11114) 'CONC   ',-IO+1,' 99 concentrazione (part/mesh)'
      write(98,11114) 'ULAMP  ',-IO+1,' 99 vel lamp (m/s)'
      write(98,11114) 'VLAMP  ',-IO+1,' 99 vel lamp (m/s)'
      write(98,11114) 'WLAMP  ',-IO+1,' 99 vel lamp (m/s)'

      write(98,11110) 'ENDVARS'

11109  format(A6,F8.2)
11110  format(50A)
11111  format(1A,'DEF ',I3,' LINEAR ',A4,A8)
11112  format(1A,'DEF ',I3,' LINEAR ',A17,I15,'mn') 
11113  format(1A,'DEF ',I3,' LINEAR ',4A)
11114  format(A5,I3,37A)
11115  format(1A,'DEF ',I3,' LEVELS ',12I6)

       close(98)
 
       stop
       end



























