clear;close all;

load findlayAREA240.txt

iint=findlayAREA240(:,1);
area240=findlayAREA240(:,2);

tempo=iint*100/86400;%[days]
%%%running average
windowSize = 60;
areai=filter(ones(1,windowSize)/windowSize,1,area240);

load meaninflow_n3408_08Feb79_30Jun79.txt
UAe=-meaninflow_n3408_08Feb79_30Jun79(:);

time2=[1/24:1/24:3408/24];%[days] cambio unita misura per UAe che ha dati ogni 1h


figure(1)
h11=line(time2,UAe,'Color','b')
ax1 = gca;
set(ax1,'XColor','k','YColor','b')
xlabel('time [days]')
ylabel('UAe [m/s]')
title('numsim=240')
ax2 = axes('Position',get(ax1,'Position'),...
           'XAxisLocation','top',...
           'YAxisLocation','right',...
           'Color','none',...
           'XColor','k','YColor','r');
h12=line(tempo,areai,'Color','r')
ylabel('area [m^2]')
set(ax2,'XTickLabel',' ')

disp('salvo figura in eps?')
pause
  orient portrait
  print(1,'-depsc2',['temp.eps'],'-loose');
