clear;close all;

load findlayAREA240.txt
area240=findlayAREA240(:,2);
raggio=sqrt(area240);

load findlayCBAR240.txt

iint=findlayCBAR240(:,1);
x240=findlayCBAR240(:,2)-4000;
y240=findlayCBAR240(:,3)-2000;

tempo=iint*100/86400;%[days]
[maxit,trash]=size(iint)

figure(1);hold on;
for it=1:100:maxit
line(x240(it),y240(it),'color',[it/maxit 0 1-it/maxit]);
%%%circle([x240(it) y240(it)],raggio(it),1000,'r-');
THETA=linspace(0,2*pi,1000);
RHO=ones(1,1000)*raggio(it);
[X,Y] = pol2cart(THETA,RHO);
X=X+x240(it);
Y=Y+x240(it);
H=plot(X,Y,'color',[it/maxit 0 1-it/maxit]);
%pause
end
text(50,40,'time [days]')
legenda=[0:tempo(maxit)/10:tempo(maxit)];
[jpippo,ipippo]=size(legenda);
for il=1:ipippo
 myred=(il/ipippo);
 text(50,40-il*5,[num2str(legenda(il))],'Color',[myred 0.2 1-myred],'FontWeight','bold');
end%il
text(0,0,'* cages')
%axis([-50 50 -50 50])
grid
xlabel('[m]')
ylabel('[m]')



