!-----------------------------------------------------------------------------! 
!-----                      MY SUBROUTINES                               -----! 
!-----------------------------------------------------------------------------! 
!16/05/02=>controllato sr myCFL, modificando il dialogo con l'utente          ! 
!                                                                             ! 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
!	SUBROUTINE DIALOGO 
! 
!	use DFLOGM 
!	include "resource.fd" 
!	type (dialog) dlg 
!	logical*4 dummyL4 
!	integer*4 dummyI4 
!-----------------------------------------------------------------------------! 
!	dummyL4=DLGINIT(IDD_DIALOG1,dlg) 
!	dummyI4=DLGMODAL(dlg) 
! 
!	dummyL4 = DlgGet( dlg, IDC_stop, dummyI4) 
!	 
!	IF(dummyI4.eq.1001)THEN	 
!	stop 
!	ENDIF 
! 
!	RETURN 
!	END 
! 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
      SUBROUTINE READpicollo(B,IM,JM) 
!-----------------------------------------------------------------------------!       
      DIMENSION A(IM,JM),B(IM,JM) 
 
      character*8 label 
      character*29 datadir 
      character*70 filein 
!-----------------------------------------------------------------------------!       
	filein='D:/andreadoglioli/picollo/BATpicollo4.txt' 
 
      open(199,file=filein,status='old') 
	 
	do j=JM,1,-1 
	 read(199,'(46E7.1)') (A(i,j), i=1,IM) 
	enddo 
 
c	rotazione attorno (1,1) e interpolazione 
	!write(0,*)'rotazione-interpolazione' 
	DXold=100. 
	DYold=100. 
	 
	DXnew=DXold !/2  !!! importante 
	DYnew=DYold !/2 
 
	iXtrasl=0 !10 
	iYtrasl=0 !10 
 
	theta=0.   !in radianti 
 
	do i=2,IM-1 
	do j=2,JM-1 
 
		xNEW=(i+iXtrasl)*DXnew 
		yNEW=(j+iYtrasl)*DYnew 
 
		xOLD=xNEW*cos(theta)-yNEW*sin(theta) 
		yOLD=xNEW*sin(theta)+yNEW*cos(theta) 
 
		xOLD=xOLD/DXold 
		yOLD=yOLD/DYold 
 
		Ixx=xOLD+iXtrasl 
		Iyy=yOLD+iYtrasl 
 
		if( (Ixx.le.1.or.Ixx.ge.IM).or. 
     !		(Iyy.le.1.or.Iyy.ge.JM)     )cycle 
 
		Fxx=xOLD-Ixx 
		Fyy=yOLD-Iyy 
 
		d1=sqrt(fxx**2+fyy**2) 
		d2=sqrt((1-fxx)**2+fyy**2) 
		d3=sqrt((1-fxx)**2+(1-fyy)**2) 
		d4=sqrt(fxx**2+(1-fyy)**2) 
 
		den=d1*d2*d3+d1*d3*d4+d1*d2*d4+d2*d3*d4 
		w1=d2*d3*d4/den 
		w2=d1*d3*d4/den 
		w3=d1*d2*d4/den 
		w4=d1*d2*d3/den 
 
		B(i,j)=w1*A(Ixx,Iyy)    +w2*A(Ixx+1,Iyy) 
     $		     +w3*A(Ixx+1,Iyy+1)+w4*A(Ixx,Iyy+1) 
	 
	enddo 
	enddo 
 
	return 
	end 
 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
	SUBROUTINE EN_CIN_2D(datadir,recNUMsim,IM,JM,iINT,UAin,VAin) 
!-----------------------------------------------------------------------------! 
      CHARACTER*3  recNUMsim 
!      CHARACTER*11 datadir 
       !CHARACTER*22 datadir 
      character*12 datadir 
	real    UAin(IM,JM),VAin(IM,JM) 
	real*8  somma,ENCIN2Dout,ROOTMS2Dout	 
!-----------------------------------------------------------------------------! 
	somma=0.	 
	ipunti=0 
	 
	do j=1,JM 
	 do i=1,IM 
	   somma=somma+0.5*( (UAin(i,j)**2) + (VAin(i,j)**2) ) 
	   ipunti=ipunti+1 
	 enddo 
	enddo 
	 
	ENCIN2Dout=somma/ipunti 
 
	ROOTMS2Dout=sqrt(ENCIN2Dout) 
 
	!write(15,'(2F22.17)') ENCIN2Dout,ROOTMS2Dout 
	open(777,file=datadir//'encin'//recNUMsim//'.txt', 
     &         status='old',access='append')                                
	write(777,'(I6,2F22.17)') iINT,ENCIN2Dout,ROOTMS2Dout 
	close(777) 
 
	return 
	end 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
	SUBROUTINE EN_CIN_3D(datadir,recNUMsim,IM,JM,KB,iINT,Uin,Vin,Win) 
!-----------------------------------------------------------------------------! 
      CHARACTER*3  recNUMsim 
!      CHARACTER*11 datadir 
	!CHARACTER*22 datadir 
      character*12 datadir 
       
	real    Uin(IM,JM,KB),Vin(IM,JM,KB),Win(IM,JM,KB) 
	real*8  somma,ENCIN3Dout,ROOTMS3Dout	 
!-----------------------------------------------------------------------------! 
 
	somma=0.	 
	ipunti=0 
	 
	do k=1,KB 
	do j=1,JM 
	do i=1,IM 
	 somma=somma+0.5*((Uin(i,j,k)**2)+(Vin(i,j,k)**2)+(Win(i,j,k)**2)) 
	 ipunti=ipunti+1 
	enddo 
	enddo 
	enddo 
	 
	ENCIN3Dout=somma/ipunti 
 
	ROOTMS3Dout=sqrt(ENCIN3Dout) 
 
	!write(15,'(2F22.17)') ENCIN3Dout,ROOTMS3Dout 
 
	open(777,file=datadir//'encin'//recNUMsim//'.txt', 
     &         status='old',access='append')                                
	write(777,'(I6,2F22.17)') iINT,ENCIN3Dout,ROOTMS3Dout 
	close(777) 
 
	return 
	end 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
	SUBROUTINE UMAX(datadir,recNUMsim,IM,JM,iINT,UAin) 
!-----------------------------------------------------------------------------! 
      CHARACTER*3  recNUMsim 
!      CHARACTER*11 datadir 
	!CHARACTER*22 datadir 
      character*12 datadir 
       
	real    UAin(IM,JM),UAmax 
!-----------------------------------------------------------------------------! 
        UAmax=0 
        imax=IM/2 
        jmax=JM 
 
        istap=95 !griglia IM=202 
        !istap=139!griglia IM=302 
         
        do i=1,istap 
         do j=JM,66,-1 
          if(UAin(i,j).gt.UAmax)then 
           UAmax=UAin(i,j) 
           imax=i 
           jmax=j 
          endif 
         enddo 
        enddo 
 
	open(777,file=datadir//'umax'//recNUMsim//'.txt', 
     &         status='old',access='append')                                
	write(777,'(3I10,F12.5)') iINT,imax,jmax,UAmax 
	close(777) 
 
	return 
	end 
 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
	SUBROUTINE XCHANGE(datadir,recNUMsim,IM,JM,iINT,UAin,Xin) 
!-----------------------------------------------------------------------------! 
      CHARACTER*3  recNUMsim 
!      CHARACTER*11 datadir 
	!CHARACTER*22 datadir 
      character*12 datadir 
       
	real    UAin(IM,JM),Xin(IM),Xcambia 
!-----------------------------------------------------------------------------! 
        Xcambia=0 
        icambia=IM/2 
        jcambia=JM-3 
 
        istap=95 !griglia IM=202 
        !istap=139!griglia IM=302 
         
        do i=1,istap 
         if(UAin(i,jcambia).gt.0.and.UAin(i-1,jcambia).lt.0)then 
          Xcambia=(Xin(IM/2)-Xin(i-1))/1000 !in km 
          icambia=i 
         endif 
        enddo 
 
	open(778,file=datadir//'xchange'//recNUMsim//'.txt', 
     &         status='old',access='append')                                
	write(778,'(3I10,F12.5)') iINT,icambia,jcambia,Xcambia 
	close(778) 
 
	return 
	end 
 
 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
	SUBROUTINE UMAX2(datadir,recNUMsim,IM,JM,iINT,UAin) 
!-----------------------------------------------------------------------------! 
      CHARACTER*3  recNUMsim 
!      CHARACTER*11 datadir 
	!CHARACTER*22 datadir 
      character*12 datadir 
       
	real    UAin(IM,JM),UAmax1,UAmax2,UAmax3 
!-----------------------------------------------------------------------------! 
        UAmax1=0 
        UAmax2=0 
        UAmax3=0 
        imax1=IM/2 
        imax2=IM/2 
        imax3=IM/2 
 
        do i=1,95 
          if(UAin(i,76).gt.UAmax1)then 
           UAmax1=UAin(i,76) 
           imax1=i 
          endif 
          if(UAin(i,72).gt.UAmax2)then 
           UAmax2=UAin(i,72) 
           imax2=i 
          endif 
          if(UAin(i,69).gt.UAmax3)then 
           UAmax3=UAin(i,69) 
           imax3=i 
          endif 
        enddo 
 
	open(777,file=datadir//'umax'//recNUMsim//'.txt', 
     &         status='old',access='append')                                
	write(777,'(I10,3(I10,F12.5))') iINT, 
     &              imax1,UAmax1,imax2,UAmax2,imax3,UAmax3 
	close(777) 
 
	return 
	end 
 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
	SUBROUTINE XCHANGE2(datadir,recNUMsim,IM,JM,iINT,UAin,Xin) 
!-----------------------------------------------------------------------------! 
      CHARACTER*3  recNUMsim 
!      CHARACTER*11 datadir 
	!CHARACTER*22 datadir 
      character*12 datadir 
       
	real    UAin(IM,JM),Xin(IM),Xcambia 
!-----------------------------------------------------------------------------! 
        Xcambia1=0 
        Xcambia2=0 
        Xcambia3=0 
        icambia1=IM/2 
        icambia2=IM/2 
        icambia3=IM/2 
 
        do i=1,95 
         if(UAin(i,76).gt.0.and.UAin(i-1,76).lt.0)then 
          Xcambia1=(Xin(IM/2)-Xin(i-1))/1000 !in km 
          icambia1=i 
         endif 
        if(UAin(i,72).gt.0.and.UAin(i-1,72).lt.0)then 
          Xcambia2=(Xin(IM/2)-Xin(i-1))/1000 !in km 
          icambia2=i 
         endif 
        if(UAin(i,69).gt.0.and.UAin(i-1,69).lt.0)then 
          Xcambia3=(Xin(IM/2)-Xin(i-1))/1000 !in km 
          icambia3=i 
         endif 
        enddo 
 
	open(778,file=datadir//'xchange'//recNUMsim//'.txt', 
     &         status='old',access='append')                                
	write(778,'(I10,3(I10,F12.5))') iINT, 
     &             icambia1,Xcambia1,icambia2,Xcambia2,icambia3,Xcambia3 
	close(778) 
 
	return 
	end 
 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
      SUBROUTINE FLUX3D(datadir,recNUMsim,IM,JM,KB,U,EL,H,FSM,DX,DZ,dif) 
	 
	!include 'comblk98_lamp.fi' 
      CHARACTER*3  recNUMsim 
      character*12 datadir 
!      CHARACTER*22 datadir 
 
      real H(IM,JM),EL(IM,JM),DX(IM,JM),DZ(KB),FSM(IM,JM),U(IM,JM,KB) 
!-----------------------------------------------------------------------------!       
	FLUXw=0. 
	do j=1,JM 
	do k=1,KB 
	  FLUXw=FLUXw+(DX(1,j)*DZ(k)*(H(1,j)+EL(1,j))*U(1,j,k)) 
     &       *FSM(1,j) 
	enddo 
	enddo 
	 
	FLUXe=0. 
	do j=1,JM 
	do k=1,KB 
	  FLUXe=FLUXe+(DX(IM,j)*DZ(k)*(H(IM,j)+EL(IM,j))*U(IM,j,k)) 
     &       *FSM(IM,j) 
	enddo 
	enddo 
 
	dif=FLUXe-FLUXw 
 
	!write(15,'(/,''  FLUXw='',E12.5,''  FLUXe='',E12.5,''  dif(E-W)='' 
      !&,E12.5)')       FLUXw,             FLUXe,             dif 
 
	open(115,file=datadir//'flux_'//recNUMsim//'.txt', 
     &         status='old',access='append')                                
	write(115,'(''  FLUXw='',E12.5,''  FLUXe='',E12.5,''  dif(E-W)='', 
     &E12.5)')       FLUXw,             FLUXe,              dif 
	close(115) 
 
 
	RETURN 
      END 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
      subroutine AVVISOAUDIO 
       
      Integer*4 freq,dur 
!-----------------------------------------------------------------------------!       
      freq=200       !!! in Hz 
      dur=1000       !!! in millisecondi 
             
      do I=1,3 
!        call BEEPQQ(freq,dur) 
        do J=1,1000000 
          irall=irall+j 
        enddo 
      enddo 
       
      return 
      end    
 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
      subroutine ERRORMESSAGE(label,TIME,IINT,IEXT) 
       
      character*8 label                                            
      character*12 datadir                                        
!      character*22 datadir       
!-----------------------------------------------------------------------------!       
!      datadir='//SuperLuasso/pomDATA/' 
      datadir='../POM_DATA/'                       
      !open(124,file=fileout,status='unknown',access='append')      
      open(124,file=datadir//label//'.txt',status='old',access='append')                                
      write(124,*) 
	write(124,*) 
	WRITE(124,'(''***********************************************'')') 
      WRITE(124,'(''************ ABNORMAL JOB END *****************'')') 
      WRITE(124,'(''************* USER TERMINATED *****************'')') 
      WRITE(124,'(''***********************************************'')') 
      write(124,'('' TIME='',F5.2,''     IINT='',I5,''     IEXT='',I5)') 
     !               TIME,               IINT,             IEXT 
      close(124)           
       
      return 
      end                                                                       
       
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
      subroutine myCFL(DTE,DX,DY,IM,JM,H,GRAV)    
!WWWWW 
!	use DFLIB 
!	type (windowconfig) wc12 
!	type (qwinfo)       winfo12 
!WWWWW 
 
!     Verifica della validita' del criterio CFL, da POMIC.f di Lionello 
!     Per la comprensione dei simboli si veda PAG 21 FORMULA 29 GUIDA98: 
!     xct e' Ct, dove Ct(H) varia a seconda del punto (i,j); 
!     umax e' la velocita' massima attesa 
!     zDxDy = quantita' racchiusa nel modulo della formula (29); 
!     xDTE = valore di DTE massimo accettabile per ciascun punto di griglia 
 
      real H(IM,JM) 
      real DX(IM,JM),DY(IM,JM) 
!-----------------------------------------------------------------------------! 
!WWWWW 
!	open(unit=12,file='user',title='unit=12   *** CFL CONTROL ***') 
!	wc12%numxpixels =800 
!	wc12%numypixels =600 
!	wc12%numtextcols=-1 
!	wc12%numtextrows=-1 
!	wc12%numcolors  =-1 
!	wc12%fontsize   =#0008000E 
!	dummyL4         =setwindowconfig(wc12) 
! 
!	winfo12.TYPE=qwin$set 
!	winfo12.X   =10 
!	winfo12.Y   =10 
!	winfo12.W   =50 
!	winfo12.H   =25 
!	dummyI4=setwsizeqq(12,winfo12) 
!WWWWW 
	Umax=1. 
!	write(12,*) 
!	write(12,*) 
!	write(12,*)' ###  Verifica della validita'' del criterio CFL  ###' 
!	write(12,*)' #  DTE  = ',DTE   
!	write(12,*)' #  GRAV = ',GRAV   
!	write(12,*)' #  Umax = ',Umax 
!	write(12,*)' #  Hmin?' 
!	read(12,*) Hmin 
	write(*,*) 
	write(*,*) 
	write(*,*)' ###  Verifica della validita'' del criterio CFL  ###' 
	write(*,*)' #  DTE  = ',DTE   
	write(*,*)' #  GRAV = ',GRAV   
	write(*,*)' #  Umax = ',Umax 
!	write(*,*)' #  Hmin?' 
!	read(*,*) Hmin 
        Hmin=1 
 
!     cerca DXmin 
      DXmin=1000000. 
      Do i=1,IM 
      Do j=1,JM 
        if (DX(i,j).lt.DXmin) then 
              DXmin=DX(i,j) 
              iDXmin=i 
              jDXmin=j 
        endif 
      enddo 
      enddo 
!      write(12,121)'  #  DXmin = DX(',iDXmin,';',jDXmin,') = ',DXmin  
      write(*,121)'  #  DXmin = DX(',iDXmin,';',jDXmin,') = ',DXmin  
!     cerca DYmin 
      DYmin=1000000. 
      Do i=1,IM 
      Do J=1,JM 
        if (DY(i,j).lt.DYmin) then 
              DYmin=DY(i,j) 
              iDYmin=i 
              jDYmin=j 
        endif 
      enddo 
      enddo 
!      write(12,121)'  #  DYmin = DY(',iDYmin,';',jDYmin,') = ',DYmin 
      write(*,121)'  #  DYmin = DY(',iDYmin,';',jDYmin,') = ',DYmin 
!     cerca Hmax 
	Hmax=Hmin 
      Do i=1,IM 
      Do J=1,JM 
        if (H(i,j).gt.Hmax) then 
              Hmax=H(i,j) 
              iHmax=i 
              jHmax=j 
        endif 
      enddo 
      enddo        
!      write(12,121)'  #  Hmax  =  H(', iHmax,';', jHmax,') = ',Hmax  
      write(*,121)'  #  Hmax  =  H(', iHmax,';', jHmax,') = ',Hmax 
121    format(A16,I3,A1,I8,A4,F9.4) 
 
!      write(12,*) 
      write(*,*) 
 
!     applica la formula 
      xDTEmin=1000000. 
      Do i=1,IM 
      Do j=1,JM 
         if(H(i,j).ge.Hmin)then  
           xct=2*sqrt((grav*H(i,j)))+Umax 
           zDxDy=1./sqrt(abs(1/DX(i,j)**2+1/DY(i,j)**2)) 
           xDTE=zDxDy/xct 
             if(xDTE.lt.xDTEmin) then 
                xDTEmin=xDTE 
                iDTE=i 
                jDTE=j 
              endif 
         endif 
      enddo 
      enddo 
 
!      write(12,122)'  #  DTEmin  (',iDTE,';',jDTE,') = ',xDTEmin 
      write(*,122)'  #  DTEmin  (',iDTE,';',jDTE,') = ',xDTEmin 
122    format(A14,I3,A1,I3,A4,F9.4) 
      IF (DTE.gt.xDTEmin) THEN      
!       write(12,*) 
!       write(12,*)' # # # # # # # # # # # # # # # # # # # # # # # # ' 
!       write(12,*)' #' 
!       write(12,*)' #    DTE > DTEmin       !!!  ATTENZIONE  !!!     ' 
!       write(12,*)' #    criterio NON soddisfatto             -> STOP' 
!       write(12,*)' #' 
!       write(12,*)' # # # # # # # # # # # # # # # # # # # # # # # # ' 
       write(*,*) 
       write(*,*)' # # # # # # # # # # # # # # # # # # # # # # # # ' 
       write(*,*)' #' 
       write(*,*)' #    DTE > DTEmin       !!!  ATTENZIONE  !!!     ' 
       write(*,*)' #    criterio NON soddisfatto             -> STOP' 
       write(*,*)' #' 
       write(*,*)' # # # # # # # # # # # # # # # # # # # # # # # # ' 
       stop 
      ELSE  
!       write(12,122)'  #  DTEmin  (',iDTE,';',jDTE,') = ',xDTEmin 
!       write(12,*) 
!       write(12,*)' #  DTE < DTEmin   ->   OK! criterio soddisfatto' 
!       write(12,*) 
!       write(12,*)'    90%DTE =',DTE/100*90 
!       read(12,*) 
!       close(12) 
       write(*,122)'  #  DTEmin  (',iDTE,';',jDTE,') = ',xDTEmin 
       write(*,*) 
       write(*,*)' #  DTE < DTEmin   ->   OK! criterio soddisfatto' 
       write(*,*) 
       write(*,*)'    90%DTEmin =',xDTEmin/100*90 
!       read(*,*) 
      ENDIF  
       
      return 
      end                                                            
       
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
      subroutine PREPARAFILE(LABEL,iEND,iPRINT,DAYS,PRTD1) 
!-----------------------------------------------------------------------------!       
      character*8 label                                             
!      CHARACTER*11 datadir 
!      character*22 datadir 
      character*12 datadir                                         
      character*24 fileout                                          
!-----------------------------------------------------------------------------!       
!      datadir='D:/pomDATA/'                        
      !datadir='//SuperLuasso/pomDATA/'                        
      datadir='../POM_DATA/'                        
      fileout=datadir//label//'.pom'                               
      open(120,file=fileout,status='unknown',access='append')       
 
      write(120,'(''iEND   = '',i9,''     DAYS  = '',f9.4)')iEND,DAYS 
      write(120,'(''iPRINT = '',i9,''     PRTD1 = '',f9.4)')iPRINT,PRTD1 
      close(120)           
       
      return 
      end                                                                       
 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
      SUBROUTINE READxy(LABEL,B,IM,JM,it) 
!-----------------------------------------------------------------------------!			      
      DIMENSION B(IM,JM), indX(IM) 
 
      character*8 label 
!      character*29 datadir 
!      character*26 datadir 
      character*12 datadir 
      character*100 filein 
!-----------------------------------------------------------------------------!       
!      datadir='//superluasso/pomDATA/INPUTS/' 
!	filein=datadir//label//'.pom'   
!      datadir='/bck_work2_nimbus/pomDATA/INPUTS/' 
      datadir='../POM_DATA/'                        
 
      filein=datadir//label//'.pom'   
 
  210 FORMAT(5X,6(2X,E12.5))                
      open(199,file=filein,status='old') 
      read(199,*) 
      read(199,*) 
 
      cols=IM/6. 
      ncols=int(cols)+1 
      isalti=it*(2+(1+JM)*ncols) 
      do i=1,isalti 
       read(199,*) 
      enddo 
 
      read(199,*) 
      read(199,*) 
      iNUMcol=0  
101   continue 
      read(199,*) 
      iNUMcolNEW=iNUMcol+6  
      do J=JM,1,-1 
        read(199,210) (B(i,j), I=iNUMcol+1,iNUMcolNEW) 
      enddo 
      iresto=IM-iNUMcolNEW 
      iNUMcol=iNUMcolNEW 
	 
	if(iresto.eq.0) goto 102 
       
	IF(iresto.gt.6)THEN    
        goto  101 
      ELSE  
        read(199,*) 
        do J=JM,1,-1 
          read(199,210) (B(i,j), I=iNUmcol+1,IM) 
        enddo  
        goto 102                              
      ENDIF     
102   continue  
      close(199)                    
 
      write(*,*)'lettura matrice 2D '//label//' eseguita!' 
!      write(*,*) i,j,B(i,j) 
 
	RETURN 
	END 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
      SUBROUTINE PRINTxy(LABEL,TIME,iINT,A,IM,ISKP,JM,JSKP) 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!			      
      DIMENSION A(IM,JM), indX(IM) 
 
!     character*8 label 
      character*8 label 
 
!     character*11 datadir 
!     character*22 datadir 
      character*12 datadir 
 
      character*24 fileout 
!------------------------------------------------------------------------------!       
!     datadir='D:/pomDATA/'                        
!     datadir='//SuperLuasso/pomDATA/'                         
      datadir='../POM_DATA/'                         
 
      fileout=datadir//label//'.pom'                                
   
  210 format( I3,2X ,6(2X,E12.5)) 
  209 format('  j;i',6(2X,I12)) ! 
   
      open(126,file=fileout,status='unknown', access='append') 
 
      write(126,*)'!!! label : ',label  
      write(126,*)'!!! time  : ',time, '       !!! IINT : ',IINT 
      iNUMcol=0    
 
10003 continue 
      iNUMcolNEW=iNUMcol+6   
          
      do i=iNUMcol+1,iNUMcolNEW,Iskp 
         indX(i)=i 
      enddo 
 
      write(126,209)(indX(i), i=iNUMcol+1,iNUMcolNEW,Iskp)    
 
      do J=JM,1,-Jskp 
         write(126,210) j,(A(i,j), I=iNUMcol+1,iNUMcolNEW,Iskp) 
      enddo 
 
      iresto=IM-iNUMcolNEW 
      iNUMcol=iNUMcolNEW 
 
      if(iresto.eq.0) goto 10004 
        
      if(iresto.gt.6)then    
      goto  10003 
 
      else  
      do i=iNUMcol+1,IM,Iskp 
         indX(i)=i 
      enddo 
 
      write(126,209)(indX(i), i=iNUMcol+1,IM,Iskp) 
 
      do J=JM,1,-1 
         write(126,210) j,(A(i,j), I=iNUMcol+1,IM,Iskp) 
      enddo  
 
      goto 10004    
      endif 
 
10004 continue 
 
      close(126) 
 
      return 
 
      end 
 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
      SUBROUTINE READxyz(LABEL,A,IM,JM,KB,it) 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!	 
      DIMENSION A(IM,JM,KB), indX(IM) 
 
      character*8 label 
      character*18 datadir 
      character*30 filein 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
      datadir='../POMDATA/INPUTS/'                        
      filein=datadir//label//'.pom'                                
 
 210  FORMAT(5X,6(2X,E12.5))                
 211  FORMAT(5X,1(2X,E12.5))                
 212  FORMAT(5X,2(2X,E12.5))                
 213  FORMAT(5X,3(2X,E12.5))                
 214  FORMAT(5X,4(2X,E12.5))                
 215  FORMAT(5X,5(2X,E12.5))                
 
      open(11,file=filein,status='old') 
 
      read(11,*) 
      read(11,*) 
 
      cols=IM/6. 
      ncols=int(cols)+1 
      isalti=it*(2+KB*(1+(1+JM)*ncols)) 
 
      do i=1,isalti 
       read(11,*) 
      enddo 
 
      do k=1,KB 
       read(11,*) 
       iNUMcol=0    
10003  continue 
       iNUMcolNEW=iNUMcol+6   
       read(11,*) 
       do J=JM,1,-1 
        read(11,210) (A(i,j,k), I=iNUMcol+1,iNUMcolNEW) 
       enddo 
       iresto=IM-iNUMcolNEW 
       iNUMcol=iNUMcolNEW 
	if(iresto.eq.0) goto 10004 
        IF(iresto.gt.6)THEN    
         goto  10003 
        ELSE  
         read(11,*) 
         do J=JM,1,-1 
          read(11,'(5X,2(2X,E12.5))') (A(i,j,k), I=iNUmcol+1,IM) 
         enddo  
         goto 10004    
        ENDIF 
10004  continue 
      enddo !su k 
 
      close(11) 
 
      write(*,*)'lettura matrice 3D '//label//' eseguita!' 
 
      return 
      end 
 
 
 
 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
      SUBROUTINE PRINTxyz(LABEL,TIME,iINT,A,IM,ISKP,JM,JSKP,KB) 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~!			      
      DIMENSION A(IM,JM,KB), indX(IM) 
 
!      character*8 label 
!      CHARACTER*11 datadir 
!      !character*22 datadir 
!      character*34 fileout 
      character*8 label 
!      character*26 datadir 
      character*12 datadir 
!      character*38 fileout 
      character*24 fileout 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
!      datadir='D:/pomDATA/'                        
       !datadir='//SuperLuasso/pomDATA/'                         
      datadir='../POM_DATA/'                         
      fileout=datadir//label//'.pom'                                
   
  210 format( I3,2X ,6(2X,E12.5)) 
  209 format('  j;i',6(2X,I12)) ! 
      open(126,file=fileout,status='unknown', access='append') 
 
      write(126,*)'!!! label : ',label  
      write(126,*)'!!! time  : ',time, '       !!! IINT : ',IINT 
 
	do k=1,KB 
	write(126,'(A6,I3)') 'layer=',k 
      iNUMcol=0    
10003  continue 
       iNUMcolNEW=iNUMcol+6   
          
	 do i=iNUMcol+1,iNUMcolNEW,Iskp 
	    indX(i)=i 
	 enddo 
	 write(126,209)(indX(i), i=iNUMcol+1,iNUMcolNEW,Iskp) 
	    
	 do J=JM,1,-Jskp 
          write(126,210) j,(A(i,j,k), I=iNUMcol+1,iNUMcolNEW,Iskp) 
       enddo 
       iresto=IM-iNUMcolNEW 
       iNUMcol=iNUMcolNEW 
	 if(iresto.eq.0) goto 10004 
        
	 IF(iresto.gt.6)THEN    
         goto  10003 
       ELSE  
         do i=iNUMcol+1,IM,Iskp 
	      indX(i)=i 
	   enddo 
	   write(126,209)(indX(i), i=iNUMcol+1,IM,Iskp) 
	   do J=JM,1,-1 
            write(126,210) j,(A(i,j,k), I=iNUmcol+1,IM,Iskp) 
         enddo  
         goto 10004    
       ENDIF 
10004  continue 
 
	enddo 
 
      close(126) 
 
      return 
      end 
 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
      SUBROUTINE PRINTxyzR(LABEL,TIME,IINT,A,IIM,ISKP,IJM,JSKP,IO)            ! 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!		      
 
      DIMENSION A(IIM,IJM,IO:0), indX(IIM) 
 
      character*8 label 
 
!     character*26 datadir 
      character*12 datadir 
 
!     character*38 fileout 
      character*24 fileout 
!-----------------------------------------------------------------------------! 
 
!     datadir='D:/pomDATA/'                        
!     datadir='//SuperLuasso/pomDATA/'                         
      datadir='../POM_DATA/'                         
 
      fileout=datadir//label//'.pom'                                
   
  210 format( I3,2X ,6(2X,E12.5)) 
  209 format('  j;i',6(2X,I12)) ! 
   
      open(126,file=fileout,status='unknown', access='append') 
 
      write(126,*)'!!! label : ',label  
      write(126,*)'!!! time  : ',time, '       !!! IINT : ',IINT 
 
      do k=0,IO,-1 
         write(126,*) 'layer=',k 
         iNUMcol=0   
 
10003 continue 
         iNUMcolNEW=iNUMcol+6   
          
         do i=iNUMcol+1,iNUMcolNEW,Iskp 
            indX(i)=i 
         enddo 
         write(126,209)(indX(i), i=iNUMcol+1,iNUMcolNEW,Iskp) 
 
         do J=IJM,1,-Jskp 
            write(126,210) j,(A(i,j,k), I=iNUMcol+1,iNUMcolNEW,Iskp) 
         enddo 
         iresto=IIM-iNUMcolNEW 
         iNUMcol=iNUMcolNEW 
         if(iresto.eq.0) goto 10004 
        
         IF(iresto.gt.6)THEN    
         goto  10003 
         ELSE  
         do i=iNUMcol+1,IIM,Iskp 
            indX(i)=i 
         enddo 
            write(126,209)(indX(i), i=iNUMcol+1,IIM,Iskp) 
         do J=IJM,1,-1 
            write(126,210) j,(A(i,j,k), I=iNUmcol+1,IIM,Iskp) 
         enddo  
         goto 10004    
         ENDIF 
10004  continue 
 
      enddo 
 
      close(126) 
 
      return 
      end 
 
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
 
 
 
 
!W~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~W! 
!	logical*4 FUNCTION INITIALSETTINGS 
 
!	use dflib 
!	use dfwin 
!	logical*4 dummyL4 
!	type(qwinfo) winfo00 
!-----------------------------------------------------------------------------! 
!	winfo00%TYPE=qwin$set 
!	winfo00%X=0 
!	winfo00%Y=0 
!	winfo00%W=1016 
!	winfo00%H=673 
!	dummyL4=setwsizeqq(qwin$framewindow,winfo00) 
!	!dummyL4=appendmenuQQ(1,$menuenabled,'E&xit'C,WINEXIT) 
!	initialsettings=.true. 
!	end function INITIALSETTINGS 
!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~! 
