clear;close all;


load findlayAREA235.txt
load findlayAREA236.txt
load findlayAREA238.txt
load findlayAREA239.txt
load findlayAREA240.txt

iint=findlayAREA240(:,1);
area235=findlayAREA235(:,2);
area236=findlayAREA236(:,2);
area238=findlayAREA238(:,2);
area239=findlayAREA239(:,2);
area240=findlayAREA240(:,2);

load meaninflow_n3408_08Feb79_30Jun79.txt
UAe=meaninflow_n3408_08Feb79_30Jun79(:);

time1=[1/12:1/12:1704/12];%[days] cambio unita misura per findlay che ha dati ogni 2h
time2=[1/24:1/24:3408/24];%[days] cambio unita misura per UAe che ha dati ogni 1h


figure(1)
subplot(2,1,1)
plot(time1,area235,'r',time1,area236,'b',time1,area238,'c',time1,area239,'g',time1,area240,'k')
legend('area235','area236','area238','area239','area240',0)
grid;
xlabel('time [days]')
ylabel('area [m^2]')
title('CONCBcrit=150')

subplot(2,1,2)
plot(time2,UAe)
grid
xlabel('time [days]')
ylabel('UAe [m/s]')
title('inflow')

disp('salvo figura in eps?')
pause
  orient portrait
  print(1,'-depsc2',['temp.eps'],'-loose');
