clear;close all;

load findlayCBAR240.txt

iint=findlayCBAR240(:,1);
x240=findlayCBAR240(:,2)-4000;
y240=findlayCBAR240(:,3)-2000;

tempo=iint*100/86400;%[days]
[maxit,trash]=size(iint)

figure(1);hold on;
for it=2:maxit
line([x240(it-1) x240(it)],[y240(it-1) y240(it)],'color',[it/maxit 0 1-it/maxit],'LineWidth',5)
end
text(50,40,'time [days]')
legenda=[0:tempo(maxit)/10:tempo(maxit)];
[jpippo,ipippo]=size(legenda);
for il=1:ipippo
 myred=(il/ipippo);
 text(50,40-il*5,[num2str(legenda(il))],'Color',[myred 0.2 1-myred],'FontWeight','bold');
end%il
text(0,0,'* cages','FontSize',20)
axis([-50 50 -50 50])
grid
xlabel('[m]')
ylabel('[m]')

disp('salvo figura in eps?')
pause
  orient portrait
  print(1,'-depsc2',['temp.eps'],'-loose');


